package cbr;

import java.util.HashSet;
import java.util.Set;

public class CBR {

	private final SimilarityFunction similarityFunction;
	private Set<Caze> cazeBase = new HashSet<>();

	public CBR(SimilarityFunction similarityFunction) {
		this.similarityFunction = similarityFunction;
	}

	public void setCazeBase(Set<Caze> cazeBase) {
		this.cazeBase = cazeBase;
	}

	public Decision makeDecision(Caze query) {
		Caze bestCaze = null;
		double bestSimilarity = Double.NEGATIVE_INFINITY;
		for (Caze caze : cazeBase) {
			double similarity = similarityFunction.calculateSimilarity(caze, query);
			if (similarity > bestSimilarity) {
				bestCaze = caze;
				bestSimilarity = similarity;
			}
		}
		return bestCaze.getDecision();
	}

	public Caze mostSimilarCaze(Caze query) {
		Caze bestCaze = null;
		double bestSimilarity = Double.NEGATIVE_INFINITY;
		for (Caze caze : cazeBase) {
			double similarity = similarityFunction.calculateSimilarity(caze, query);
			if (similarity > bestSimilarity) {
				bestCaze = caze;
				bestSimilarity = similarity;
			}
		}
		return bestCaze;
	}
}
