package cbr;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.text.ParseException;
import java.util.HashSet;
import java.util.Set;

import org.apache.commons.csv.CSVFormat;
import org.apache.commons.csv.CSVParser;
import org.apache.commons.csv.CSVRecord;

public class CazeFileReader {

	public static Set<Caze> readFile(File file) throws IOException, ParseException {
		CSVParser parser = CSVParser.parse(file, Charset.defaultCharset(),
				CSVFormat.DEFAULT.withDelimiter(';').withHeader());
		Set<Caze> cazes = new HashSet<>();
		for (CSVRecord record : parser) {
			cazes.add(Caze.fromCazeFileRecord(record.toMap()));
		}
		return cazes;
	}
}
