package ea;

import java.util.Collections;
import java.util.HashSet;
import java.util.Set;

public class AdultSelector {

	public static final int REPLACEMENT_MODE = 0;
	public static final int MIXING_MODE = 1;

	private int noAdults;
	private int mode;

	public AdultSelector(int noAdults) {
		this.noAdults = noAdults;
		this.mode = REPLACEMENT_MODE;
	}

	public AdultSelector(int noAdults, int mode) {
		this.noAdults = noAdults;
		this.mode = mode;
	}

	public Set<Individual> selectAdults(Set<Individual> adults, Set<Individual> children) {
		Set<Individual> individuals = new HashSet<Individual>();
		switch (mode) {
		case REPLACEMENT_MODE:
			individuals.addAll(children);
			break;
		case MIXING_MODE:
			individuals.addAll(adults);
			individuals.addAll(children);
			break;
		}
		while (individuals.size() > noAdults) {
			Individual minIndividual = Collections.min(individuals);
			individuals.remove(minIndividual);
		}
		return individuals;
	}

	public int getNoAdults() {
		return noAdults;
	}
}
