package ea;

import ea.BitVectorIndividual;
import ea.Individual;

public class ByteArrayIndividual extends BitVectorIndividual {

	public ByteArrayIndividual(int length) {
		super(8 * length);
	}

	protected ByteArrayIndividual(boolean[] genome) {
		super(genome);
	}

	@Override
	protected BitVectorIndividual newIndividual(boolean[] genome, Individual individual) {
		return new ByteArrayIndividual(genome);
	}

	public int[] getByteArray() {
		boolean[] bitVector = getBitVector();
		int[] byteArray = new int[bitVector.length / 8];
		for (int i = 0; i < byteArray.length; i++) {
			byteArray[i] = 0;
			for (int b = 0; b < 8; b++) {
				byteArray[i] <<= 1;
				byteArray[i] += (bitVector[8 * i + b] ? 1 : 0);
			}
		}
		return byteArray;
	}

	@Override
	public String phenomeString() {
		int[] byteArray = getByteArray();
		String phenome = "";
		for (int i = 0; i < byteArray.length; i++) {
			phenome += byteArray[i] + ", ";
		}
		phenome = phenome.substring(0, phenome.length() - 2);
		return phenome;
	}
}
